﻿#!/usr/bin/perl

# 2.
# Оплата заданной суммы с выбором валюты на сайте ROBOKASSA
# Payment of the set sum with a choice of currency on site ROBOKASSA

# подключение стандартного модуля для кодирования подписи
# standard module for coding the signature
use Digest::MD5 qw(md5_hex);

# регистрационная информация (логин, пароль #1)
# registration info (login, password #1)
my $mrh_login = "demo";
my $mrh_pass1 = "password_1";

# номер заказа
# number of order
my $inv_id = 0;               

# описание заказа
# order description
my $inv_desc = "ROBOKASSA Advanced User Guide";

# сумма заказа
# sum of order
my $out_summ = "8.96";

# тип товара
# code of goods
my $shp_item = "2";

# предлагаемая валюта платежа
# default payment e-currency
my $in_curr = "";

# язык
# language
my $culture = "ru";

# формирование подписи
# generate signature
my $crc = md5_hex("$mrh_login:$out_summ:$inv_id:$mrh_pass1:Shp_item=$shp_item");

# форма оплаты товара
# payment form
print "Content-type: text/html\n\n";
print <<EOF;
<html>
<form action="https://merchant.roboxchange.com/Index.aspx" method=POST>
<input type=hidden name=MrchLogin value=$mrh_login>
<input type=hidden name=OutSum value=$out_summ>
<input type=hidden name=InvId value=$inv_id>
<input type=hidden name=Desc value="$inv_desc">
<input type=hidden name=SignatureValue value=$crc>
<input type=hidden name=Shp_item value="$shp_item">
<input type=hidden name=IncCurrLabel value=$in_curr>
<input type=hidden name=Culture value=$culture>
<input type=submit value="Pay">
</form>
</html>
EOF
print "\n\n";