﻿#!/usr/bin/perl

# подключение стандартного модуля для кодирования подписи
# standard module for coding the signature
use Digest::MD5 qw(md5_hex);

# подключение стандартного модуля для работы с базами даннных
# standard module for databases access
use DBI;

require("http_Prm.cgi");

# текущая дата
# current date
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =  gmtime(time());
my $tm = sprintf("%04d-%02d-%02d %02d:%02d:%02d",
    $year+1900, $mon+1, $mday, $hour, $min, $sec);

# регистрационная информация
# registration info
my $mrh_pass2 = "password_2"; # пароль2

my %q = http_Prm();
# считывание параметров
# read parameters
$q{SignatureValue} =~ s/([a-z])/uc "$1"/eg;   # force uppercase

# формирование подписи
# generate signature
my $my_crc = md5_hex("$q{OutSum}:$q{InvId}:$mrh_pass2:Shp_item="$q{Shp_item});
$my_crc =~ s/([a-z])/uc "$1"/eg;   # force uppercase

# проверка подписи
# check signature
my $is_correct = ($my_crc eq $q{SignatureValue} ? 1 : 0);

if (!$is_correct)
{
  print "Content-type: text/html\n\nbad sign\n";
  die "incorrect sign passed";
}

# признак успешно проведенной операции
# success
print "Content-type: text/html\n\nOK$q{InvId}\n";

# подключение к базе данных
# connect to db
my $dbh = DBI->connect("DBI:mysql:database=database_name",
      "login", "pass");

# добавление в таблицу order1 информации о проделаной операции
# append operation info to table order1
$dbh->do
        ("INSERT INTO order1

        (order_num, summ, date)
        VALUES
        ('$q{InvId}', '$q{OutSum}', '$tm')");


if (length($dbh->errstr) > 0)
  { print $dbh->errstr; }

exit();
